package Html_Engine;

public abstract class Control {

    //ID
    protected String strID;

    //CSS Class
    protected String strCSSClass;

    //Mouse Hover Title
    protected String strTitle;

    //Inline Style Rules
    protected String strStyle;

    //OnClick JavaScript Code
    protected String strOnClick;

    //Name
    protected String strName;
    
    //Constructor
    public Control(){
        strID = "";
        strCSSClass = "";
        strTitle = "";
        strStyle = "";
	strOnClick = "";
	strName = "";
    }
    
    //Pre: inID is a non-null string
    //Post: html element id is set to inID
    public void setID(String inID){
        strID = inID;
    }
    
    //Pre: inClass is a non-null string
    //Post: cssclass is set to inClass
    public void setCSSClass(String inClass){
        strCSSClass = inClass;
    }
    
    //Pre: inTitle is a non-null string
    //Post: mouseover title is set to inTitle
    public void setTitle(String inTitle){
        strTitle = inTitle;
    }
    
    //Pre: inStyle is a non-null string
    //Post: inline style is set to inStyle
    public void setStyle(String inStyle){
        strStyle = inStyle;
    }

    //Pre: inClick is a non-null string
    //Post: onclick javascript is set to inClick
    public void setOnClick(String inClick){
	strOnClick = inClick;
    }

    //Pre: inName is a non-null string
    //Post: html element name is set to inName
    public void setName(String inName){
	strName = inName;
    }

    //Pre: none
    //Post: for each attribute, if it is not empty it is added to the 
    //string of attributes
    protected String getStandardAttributes(){
        String attr = new String();
        
        if (!strID.equals(""))
            attr = attr + "id=\"" + strID + "\" ";
        
        if (!strCSSClass.equals(""))
            attr = attr + "class=\"" + strCSSClass + "\" ";
        
        if (!strTitle.equals(""))
            attr = attr + "title=\"" + strTitle + "\" ";
        
        if (!strStyle.equals(""))
            attr = attr + "style=\"" + strStyle + "\" ";
	
		if (!strOnClick.equals(""))
            attr = attr + "onclick=\"" + strOnClick + "\" ";

		if (!strName.equals(""))
			attr = attr + "name=\"" + strName + "\" ";

        return attr;
    }
    
    //Pre: none
    //Post: returns the html equivalent for the object
    public abstract String toString();
    
}
