package Html_Engine;

import java.lang.reflect.*;

public class DataGrid extends Control {

	//boolean to tell if the first row of the data is headers
    private boolean firstRowTitle;

	//sets the border settings
    private String strBorder;

	//sets the tablecell spacing
    private String strSpacing;

	//the data set
    private Object[][] dataTable;
    
	//Pre: none
	//Post:  the DataGrid is initialized
    public DataGrid(){
        super();
        strBorder = "0";
        strSpacing = "0";
    }
    
	//Pre:  arrData is a 2D array of objects with meaningful toString() methods
	//Post:  the dataTable is set to arrData
    public void setDataSource(Object[][] arrData){
        dataTable = arrData;
    }
    
	//Pre:  none
	//Post:  the border attribute is set to inBorder
    public void setBorder(String inBorder){
        strBorder = inBorder;
    }
    
	//Pre:  none
	//Post:  firstRowTitle is either turned on or off
    public void setFirstRowTitle(boolean inValue){
        firstRowTitle = inValue;
    }
 
	//Pre: none
	//Post:  returns the string equivalent of the DataGrid
    public String toString() 
	{
        String table = "<table " + getStandardAttributes() + "border=\"" + strBorder + "\" cellspacing=\"" + strSpacing + "\">";
        try{
        if(dataTable != null){
            for(int rowNum = 0; rowNum < Array.getLength(dataTable); rowNum++){
                table = table + "<tr>";
                for(int colNum = 0; colNum < Array.getLength(dataTable[rowNum]); colNum++){
                    if(rowNum == 0 && firstRowTitle && dataTable[rowNum][colNum] != null)
                        table = table + "<th class=\"column" + colNum + "\">" + dataTable[rowNum][colNum].toString() + "</th>";
                    else if (dataTable[rowNum][colNum] != null)
                        table = table + "<td class=\"column" + colNum + "\">" + dataTable[rowNum][colNum].toString() + "</td>";
		    else
			table = table + "<td class=\"column" + colNum + "\"><hr>" + "</td>";
                }
                table = table + "</tr>\n";
            }
        }
	}catch(Exception e) { e.printStackTrace(); }
        
        table = table + "</table>";
        return table;
    }

}
