package Html_Engine;

import java.util.ArrayList;

public class Form extends Control {

	//target
    private String strTarget;

	//form action, page that will be POST or GET 
    private String strAction;

	//form method POST or GET
    private String strMethod;

	//List of elements to go in the form (html or strings)
    private ArrayList objControls;
    
	//Pre:  inMethod is either POST or GET, and inAction is a valid page to submit to
	//Post:  the form is initialized
    public Form(String inMethod, String inAction){
        strMethod = inMethod;
        strAction = inAction;
        strName = "";
        strTarget = "";
        objControls = new ArrayList();
    }
    
	//Pre:  none
	//Post:  the target is set to strTarget
    public void setTarget(String inTarget){
        strTarget = inTarget;
    }
    
	//Pre: inObj is an object with a meaningful toString(), like the Control classes
	//     or String itself
	//Post:  inObj is added to the list of controls
    public void add(Object inItem)
	{
        objControls.add(inItem);
    }
    
	//Pre: none
	//Post:  returns the string equivalent of the Form
    public String toString() 
	{
        String form = "<form " + this.getStandardAttributes() + " " + "method=\"" + strMethod + "\" action=\"" + strAction + "\" ";
        
        if(!strTarget.equals(""))
            form = form + "target=\"" + strTarget + "\" ";
        
        form = form + " >";
        
        objControls.trimToSize();
        for(int i = 0; i < objControls.size(); i++){
            form = form + objControls.get(i).toString() + "\n";
        }
        
        form = form + "</form>\n";
        
        
        return form;
    }

}
