package Html_Engine;

public class Image extends Control {

	//the image web address
    private String strSrc;

	//the image alternate text
    private String strAlt;
    
	//Pre:  inSrc is a valid picture web address, inAlt is non-null alternate text
	//Post:  strSrc and strAlt are set to inSrc and inAlt respectively
    public Image(String inSrc, String inAlt){
        strSrc = inSrc;
        strAlt = inAlt;
    }
    
	//Pre:  none
	//Post: sets the picture web address
    public void setSrc(String inSrc){
        strSrc = inSrc;
    }
    
	//Pre:  none
	//Post:  sets the picture alternate text
    public void setAlt(String inAlt)
	{
        strAlt = inAlt;
    }
    
	//Pre:  none
	//Post:  returns the web address for the image
	public String getSrc()
	{
		return strSrc;
	}

	//Pre:  none
	//Post:  returns the alternate text
	public String getAlt()
	{
		return strAlt;
	}

	//Pre:  none
	//Post:  returns the string equivalent of the Image
    public String toString() 
	{
        return "<img " + getStandardAttributes() + " src=\"" + strSrc + "\" alt=\"" + strAlt + "\"" + "/>";
    }

}
