package Html_Engine;
import java.util.ArrayList;

public class Link extends Control {

    //Page linked two
    private String strHref;

    //Target window
    private String strTarget;

    //list of html objects
    private ArrayList objControls;
    
    //Constructor
    public Link(){
        super();
        strHref = "";
        strTarget = "";
        objControls = new ArrayList();
    }
    
    //Pre: inHref is a non-null string
    //Post: strHref is set to inHref
    public void setHref(String inHref){
        strHref = inHref;
    }
    
    //Pre: inTarget is a non-null string
    //Post: strTarget is set to inTarget
    public void setTarget(String inTarget){
        strTarget = inTarget;
    }
    
    //Pre: inObj is a non-null object
    //Post: inObj is added to the list
    public void add(Object inObj){
        objControls.add(inObj);
    }
    
    //Pre: none
    //Post: the link is made into an html tage and returned
    public String toString() {
        String link = "<a ";
        
        link = link + super.getStandardAttributes();
        
        if (strHref.equals(""))
            link = link + "href=\"#\" ";
        else
            link = link + "href=\"" + strHref + "\" ";
        
        if (!strTarget.equals(""))
            link = link + "target=\"" + strTarget + "\"";
        
        link = link + "> ";
        
        if (objControls.size() != 0){
            for(int i = 0; i < objControls.size(); i++){
                link = link + objControls.get(i).toString();
            }
        }
        else
            link = link + "Click Here";
        
        link = link + "</a>";
        
        return link;
    }

}
