package Html_Engine;
import java.util.ArrayList;

public class List extends Control {

	//An array for the list elements
    private ArrayList items;

	//boolean that tells if the list is ordered (true) or not (false)
    private boolean ordered;
    
	//Pre:  none
	//Post: the list data members are initialized
    public List(){
        items = new ArrayList();
        ordered = false;
    }
    
	//Pre:  none
	//Post:  ordered is set to inOrdered
    public void setOrdered(boolean inOrdered){
        ordered = inOrdered;
    }
    
	//Pre: inItem is an object with a meaningful toString(), like the Control classes
	//     or String itself
	//Post:  inItem is added to the list of controls
    public void addItem(Object inItem)
	{
        items.add(inItem);
    }
    
	//Pre:  none
	//Post:  returns the string equivalent of the List
    public String toString() 
	{
        String list = "";
        
        if (ordered)
            list = list + "<ol>\n";
        else
            list = list + "<ul>\n";
        
        items.trimToSize();
        for(int i = 0; i < items.size(); i++){
            list = list + "<li>" + items.get(i).toString() + "</li>\n"; 
        }
        
        if (ordered)
            list = list + "</ol>\n";
        else
            list = list + "</ul>\n";
        
        return list;
    }

}
