
package Html_Engine;

import java.util.ArrayList;

public class Page {

    //Page title
    private String strTitle;

    //Header links
    private String strLinks;

    //Page JavaScript
    private String strJScript;

    //Page control list
    private ArrayList objControls;

    //Body tag's onLoad function
    private String strOnBodyLoad;

    //Constructor w/o title
    public Page(){
	strTitle = "untitled";
	strLinks = "";
	strJScript = "";
	objControls = new ArrayList();
    }
    
    //Constructor w/ title
    public Page(String inTitle){
        strTitle = inTitle;
        strLinks = "";
        strJScript = "";
        objControls = new ArrayList();
    }
    
    //Pre: inTitle is a non-null string
    //Post: page title is set to inTitle
    public void setTitle(String inTitle){
        strTitle = inTitle;
    }
    
    //Pre: inJScript is a non-null string containing javascript
    //Post: javascript is set to inJSCript
    public void setJavaScript(String inJScript){
        strJScript = inJScript;
    }
    
    //Pre: rel is a non-null string, and href is a non-null string
    //Post: a link is formed and added to the strLinks string
    public void addLink(String rel, String href){
        strLinks = strLinks + "<link href=\"" + href + "\" rel=\"" + rel + "\"/>";
    }
    
    //Pre: inScript is a non-null string
    //Post: the onload javascript for the body tag is set to InScript
    public void setOnBodyLoad(String inScript){
	strOnBodyLoad = inScript;
    }

    //Pre: none
    //Post: resets the links is set to the empty string ("")
    public void clearLinks(){
        strLinks = "";
    }

    //Pre: none
    //Post: creates the first parts of the page from <html>...<body>
    private String createHeader(){
        String strHeader = "<html>\n<head>\n<title>" + strTitle + "</title>\n" + strLinks + "</head>\n<script>\n" + strJScript + "</script>\n<body onload=\"" + strOnBodyLoad + "\" >\n";
        return strHeader;
    }
    
    //Pre: inControl is a non-null object
    //Post: adds inControl to the array of objects to display on the page
    public void add(Object inControl){
        objControls.add(inControl);
    }
    
    //Pre: none
    //Post: creates the html code representing the page and returns it as a string
    public String toHtml(){
        
        String strHtml = createHeader();
        
        for(int i = 0; i < objControls.size(); i++){
           strHtml = strHtml + objControls.get(i).toString();
        }
        
        strHtml = strHtml + "</body>\n</html>";
        
        return strHtml;   
        
    }
}
