package Html_Engine;
import java.util.ArrayList;

public class Table extends Control {
    
	//List of rows
    private ArrayList objRows;

	//Border setting
    private String strBorder;

	//Table padding
    private String strPadding;
    
    //Pre: none
	//Post:  Table is initialized
    public Table(){
	strBorder = "0";
	strPadding = "0";	
	objRows	 = new ArrayList();
    }
    
	//Pre:  inBorder is a valid string
	//Post:  the border setting is set to inBorder
    public void setBorder(String inBorder){
	strBorder = inBorder;
    }
    
	//Pre:  inPadding is a valid string
	//Post:  the table padding is set to inPadding
    public void setPadding(String inPadding){
	strPadding = inPadding;
    }
    
	//Pre:  inRow is a valid TableRow item
	//Post:  inRow is added to the list of Rows
    public void addRow(TableRow inRow){
	objRows.add(inRow);
    }
        
	//Pre:  none
	//Post:  returns the string equivalent of the Table
    public String toString() 
	{
	String strTable = "<table " + this.getStandardAttributes() + " border=\"" + strBorder + "\" cellpadding=\"" +
	    strPadding + "\" cellspacing=0 >\n";
	
	objRows.trimToSize();
	
	for(int i = 0; i < objRows.size(); i++){
	    strTable = strTable + objRows.get(i).toString();
	}
	strTable = strTable + "</table>\n";
	return strTable;
    }

}
