package Html_Engine;

import java.util.ArrayList;

public class TableCell extends Control {

	//List of elements to go in the cell (html or strings)
    private ArrayList objControls;

	//td, th attribute for column span
    private String strColSpan;

	//td, th attribute for row span
    private String strRowSpan;

	//determines whether the cell is a <td> or a <th>
    private boolean isHeader;
    
	//Pre: none
	//Post: Initializes the cell's data members
    public TableCell(){
	objControls = new ArrayList();
	strColSpan = "1";
	strRowSpan = "1";
	isHeader = false;
    }
    
	//Pre: none
	//Post:  the column span is set to inStr
    public void setColSpan(String inStr){
	strColSpan = inStr;	
    }
    
	//Pre: none
	//Post:  the row span is set to inStr
    public void setRowSpan(String inStr){
	strRowSpan = inStr;	
    }
    
	//Pre: inObj is an object with a meaningful toString(), like the Control classes
	//     or String itself
	//Post:  inObj is added to the list of controls
    public void add(Object inObj){
	objControls.add(inObj);
    }
    
	//Pre: none
	//Post: isHeader is set to inHeader
    public void setHeader(boolean inHeader){
	isHeader = inHeader;
    }
    
	//Pre: none
	//Post:  returns the string equivalent of the TableCell
    public String toString() {
	String cell;
	if(isHeader){
	    cell = "<th ";
	}
	else
	    cell = "<td ";
	
	cell = cell + "colspan=\"" + strColSpan + "\" rowspan=\"" + strRowSpan + "\" " + this.getStandardAttributes() + " >";
	
	for(int i = 0; i < objControls.size(); i++){
	    cell = cell + objControls.get(i).toString();			 
	}
	
	if(isHeader)
	    cell = cell + "</th>\n";
	else
	    cell = cell + "</td>\n"; 
	return cell;
    }
    
}
