import java.util.Calendar;
import java.util.GregorianCalendar;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DateFormat;

public class LogWriter
{
    private File fileCurrent;
    private String strFileName;
    private GregorianCalendar cal;

    //Pre:  none
    //Post: none, LogWriter is allocated
    public LogWriter(){  }

    //Pre:  strIP is a non-null string, strPath is a non-null string
    //Post: an entry is made to the log file for the day, which includes
    //      the IP, path, date and time
    public void writeEntry(String strIP, String strPath){
	try{
	    FileWriter fw;
	    cal = new GregorianCalendar();
	    strFileName = createFileName(cal);
	    fileCurrent = new File("./logs/" + strFileName);
	    fileCurrent.createNewFile();
	    fw = new FileWriter(fileCurrent,true);
	    fw.write(strIP + "," + strPath + "," + cal.getTime().toString() + "\n");
	    fw.close();
	}catch (IOException e) { e.printStackTrace(); }
    }

    //Pre:  inCal is a calendar which contains the current day
    //Post: returns a string which is the name of a log file in the form
    //      MM-DD-YY.log
    private String createFileName(Calendar inCal){

	String date = DateFormat.getDateInstance(DateFormat.SHORT).format(inCal.getTime()).replaceAll("/","-");
	
	return date + ".log";
    }

}
