import java.util.*;

/*
 * Created on Oct 27, 2004
 * By Evan Kaiser, Don Frehulfer, and Matt Berntsen
 * CS 479 - Capstone Design
 */

public class PageContentList{
    private ArrayList list;
    private Semaphore s;
    private int timesAcquired, timesReleased;

    //Pre:  inS is a reference to a Semaphore created in RunCrawler
    //Post: Set local Semaphore s to inS, and instantiate list.
    public PageContentList(Semaphore inS){
	list = new ArrayList(0);
	s = inS;
	//	timesAcquired = timesReleased = 0;
    }

    //Pre:  inPage is a reference to a PageContent created in Crawler or Parser.
    //Post: Add page to local field, list.
    public void addSite(PageContent inPage){
	s.acquire();
	//	timesAcquired++;
	//System.out.println("Semaphore acquired in function addSite.");
	list.add(inPage);
	s.release();
	//	timesReleased++;
	//System.out.println("Semaphore released in function addSite.");
	return;
    }

    //Pre:  none
    //Post: Remove last item from list and return the PageContent, item.
    public PageContent getLastSite(){
	s.acquire();
	//	timesAcquired++;
	//System.out.println("Semaphore acquired in function getSite.");
	PageContent item = new PageContent("","","","","","");
	if(list.size() > 0)
	    item = (PageContent)list.remove(list.size()-1);
	s.release();
	//	timesReleased++;
	//System.out.println("Semaphore released in function getSite.");
	return item;
    }

    //Pre:  none
    //Post: Return size of list.
    public int getSize(){
	int size;
	s.acquire();
	//	timesAcquired++;
	//System.out.println("Semaphore acquired in function getSize.");
	size = list.size();
	s.release();
	//	timesReleased++;
	//System.out.println("Semaphore released in function getSize.");
	return size;
    }
    /*

    public int getTimesAcquired(){
	return timesAcquired;
    }

    public int getTimesReleased(){
	return timesReleased;
    }
    //CCThread and Parser will call this to nap
    public void nap() {
	try{
	    Thread.wait();
	}
	catch(InterruptedException e) { System.out.println(e); }
    }

    //CCThread and Parser will call this to wake up other thread
    public void wakeUp() {
	try{
	    Thread.notify();
	}
	catch(IllegalMonitorStateException e) { System.out.println(e); }
    }
    */
}
