import java.lang.reflect.*;
import java.util.*;
import java.io.*;

public class PostData{

    private Hashtable htFormData;
    private ArrayList objKeys;
    private ArrayList objValues;

    //Pre:  sockIn is a socket connection to the browser where the post data is contained
    //      http_data is a hash table that has header information
    //Post: the post data object is created
    public PostData(BufferedReader sockIn, Hashtable http_data){

	try{
	    String inBuffer;
	    String returnString = "";
	    
	    int returnStatus;
	    int returnLength;

	    objKeys = new ArrayList();
	    objValues = new ArrayList();
	    
	    if (http_data.get("content-length") == null) 
		return;
	    int dataLength = Integer.parseInt
		(((String)http_data.get("content-length")).trim());
	    
	    //System.out.println("data length " + dataLength);
	    
	    char[] inChars = new char[dataLength];
	    
	    sockIn.read(inChars, 0, dataLength);
	    
	    inBuffer = new String(inChars);
	    
	    // for debugging only
	    //System.out.println(inBuffer);
	    
	    //
	    // Parse the CGI input string
	    //
	
	    htFormData = Html.ParseToken(inBuffer);

	    int i = 0;
	    for (Enumeration e = htFormData.keys() ; e.hasMoreElements() ;){
		objKeys.add((String)e.nextElement());
		objValues.add((String)htFormData.get(objKeys.get(i)));
		i++;
	    }
	    
	}catch(Exception e) { e.printStackTrace(); }

    }

    //Pre:  none
    //Post: returns true if there are not entries, false otherwise
    public boolean isEmpty(){
	return objKeys.isEmpty();
    }

    //Pre:  inKey is a non-null string
    //Post: returns whether there is an entry with key equal to inKey
    public boolean contains(String inKey){
	return objKeys.contains(inKey.toLowerCase());
    }
    
    //Pre:  inKey is a non-null string
    //Post: returns the value associated with inKey
    public String getValue(String inKey){
	int intPos = objKeys.indexOf(inKey);
	
     	if(intPos >= 0){
	    String value = (String)objValues.get(intPos);
	    return (String)objValues.get(intPos);
	}
	else
	    return "";
    }

}
