import java.lang.reflect.*;
import java.util.*;

public class QueryString{

    private String strQuery;
    ArrayList objKeys;
    ArrayList objValues;

    //Pre:  inQuery is a path with a query string, or just the query string
    //Post: the query string is split into keys and values
    public QueryString(String inQuery){

	objKeys = new ArrayList();
	objValues = new ArrayList();

	if(inQuery.charAt(0) == '?')
	    strQuery = inQuery.substring(1,inQuery.length());
	else if(inQuery.indexOf("?") > 0)
	    strQuery = inQuery.substring(inQuery.indexOf("?") +1, inQuery.length());
	else
	    return;


	parseString();
    }

    //Pre:  none
    //Post: parses the post data and fills objKeys and objValues
    private void parseString(){
	String[] arrPairs = strQuery.split("&");
	String[] temp;

	for(int i = 0; i < Array.getLength(arrPairs); i++){
	    temp = arrPairs[i].split("=");
	    objKeys.add(temp[0].toLowerCase());
	    if (Array.getLength(temp) > 1)
		objValues.add(temp[1].replace('+',' '));
	    else
		objValues.add("");
	}

	objKeys.trimToSize();
	objValues.trimToSize();
	
	//	for(int i = 0; i < objKeys.size();i++){
	//   System.out.println("Key: " + objKeys.get(i) + " || Value = " + objValues.get(i));
	//}
    }

    //Pre:  inKey is a non-null string
    //Post: returns whether inKey is a key in the query string
    public boolean contains(String inKey){
	return objKeys.contains(inKey.toLowerCase());
    }

    //Pre:  inKey is a non-null string
    //Post: returns the value that corresponds with inKey
    public String getValue(String inKey){
	int intPos = objKeys.indexOf(inKey.toLowerCase());
	
	//System.out.print("(" +inKey + "," + intPos + ")");

	if(intPos >= 0)
	    return (String)objValues.get(intPos);
	else
	    return "";
    }

}
