import java.sql.*;

public class cc_db{
    private Connection con;
    private Statement stmt;
    private ResultSet rset;

    // Constructor
    public cc_db(){
	// Database server DNS address
	String dbHost = "db.eg.bucknell.edu";
	// Database Name
	String dbName = "cs479c";
	// Database Username
	String username = "cs479c";
	// Database Password
	String password = "HGWJS39S";
	try{
	    Class.forName("com.mysql.jdbc.Driver").newInstance();
	}catch (Exception ex){}
	try{
	    con = DriverManager.getConnection("jdbc:mysql://" + dbHost + "/" + 
					  dbName + "?user=" + username + 
					  "&password=" + password + "&autoReconnect=" + true);
	    stmt = con.createStatement();
	}catch(SQLException e){ processException(e); }
    }


    /**************
     CCRAWLER_ADMIN
     **************/
    
    // Pre:  None.
    // Post: An object containing the dates of interest.
    public Object[][] cc_admin_get_dates(){
	Object[][] rtn = null;

	try{
	    rset = stmt.executeQuery("SELECT admin_last AS \"Last Login At\", admin_last_crawl AS \"Last Crawled On\", " +
				     "admin_last_clean AS \"Last Cleaned On\" FROM ccrawler_admin");
	    rset.first();
	    rtn = new Object[2][3];
	    for(int i = 0; i <= 1; i++){
		if(i == 0){
		    rtn[0][0] = rset.getMetaData().getColumnName(1);
		    rtn[0][1] = rset.getMetaData().getColumnName(2);
		    rtn[0][2] = rset.getMetaData().getColumnName(3);
		}
		    
		else{
		    rtn[i][0] = rset.getObject(1);
		    rtn[i][1] = rset.getObject(2);
		    rtn[i][2] = rset.getObject(3);
		    rset.next();
		}
	    }

	}catch(SQLException e){processException(e);}
	return rtn;
    }


    // Pre:  inPassword is a valid string.
    // Post: Returns true is inPassword matches the password in the DB. Else,
    // returns false.
    public boolean cc_admin_validate_pass(String inPassword){
	boolean rtn = false;
	try{
	    rset = stmt.executeQuery("SELECT * FROM ccrawler_admin WHERE admin_password=\"" +
				     inPassword +"\"");
	    rtn = rset.next();
	}catch(SQLException e){ processException(e); }	
	return rtn;
    }

    // Pre:  inIP is a valid String representation of an IP.
    // Post: if there is a valid session w/ the specified IP, return
    // true. Else return false.
    public boolean cc_admin_validate_ip(String inIP){
	boolean rtn = false;
	try{
	    rset = stmt.executeQuery("SELECT admin_current FROM ccrawler_admin WHERE admin_current = 1 AND " +
				     "admin_cur_ip = \"" + inIP + "\" AND admin_last + (admin_expire * 100) " +
				     " - CURRENT_TIMESTAMP() >= 0");
				     
	    rtn = rset.next();
	}catch(SQLException e){ processException(e); } 
	return rtn;
    }

    // Pre: None.
    // Post: If the last crawl (admin_last_crawl) occurred admin_freq or more
    // days prior to the present date, return true. Else return false.
    public boolean cc_admin_crawl(){
	try{
	    rset = stmt.executeQuery("SELECT admin_last_crawl + admin_freq - CURRENT_DATE() FROM "
				     + "ccrawler_admin");
	    rset.next();
	    int days = rset.getInt(1);
	    if (days < 0)
		return true;
	}catch(SQLException e){ processException(e); }	
	return false;
    }

    // Pre:  None.
    // Post: last crawl date is set to current.
    public void cc_admin_setCrawl(){
	try{
	    stmt.executeUpdate("UPDATE ccrawler_admin SET admin_last_crawl = NOW()");
	}catch(SQLException e){ processException(e); }	
    }

    // Pre:  inIP is a validString representation of an IP.
    // Post: Begins a session for the specified IP.
    public void cc_admin_start_session(String inIP){
	try{
	    stmt.executeUpdate("UPDATE ccrawler_admin SET admin_current=1, admin_cur_ip= \"" + inIP +
			       "\", admin_last= CURRENT_TIMESTAMP()");
	}catch(SQLException e){ processException(e); }  
    }

    // Pre:  None.
    // Post: sets admin_current to zero, logging admin user out.
    public void cc_admin_end_session(){
	try{
	    stmt.executeUpdate("UPDATE ccrawler_admin SET admin_current=0");
	}catch(SQLException e){ processException(e); } 
    }

    // Pre:  None.
    // Post: returns the contents (single row) of the ccrawler_admin table.
    public Object[][] cc_admin_list(){
	Object[][] rtn = new Object[2][3];
	try{
	    rset = stmt.executeQuery("SELECT admin_expire, admin_log, " +
				     "admin_freq FROM ccrawler_admin");
	    rset.next();
	    for(int i = 1; i < 4; i++){
		rtn[0][i-1] = rset.getMetaData().getColumnName(i);
	    } 
	    for(int i = 1; i < 4; i++){
		rtn[1][i-1] = rset.getObject(i);
	    }

	}catch(SQLException e){ processException(e); }  
	return rtn;
    }

    // Pre:  inOld and inNew are valid passwords.
    // Post: if inOld is not correct password, or form on inNew is invalid,
    // return false. Else, return true and set password to inNew.
    public boolean cc_admin_change_pass(String inOld, String inNew){
	boolean rtn = false;
	if(inOld.length() > 50 || inNew.length() > 50)
	    return false;
	try{
	    stmt.executeUpdate("UPDATE ccrawler_admin SET admin_password=\"" + inNew +
			       "\" WHERE admin_password=\"" + inOld + "\"");
	    rset = stmt.executeQuery("SELECT * FROM ccrawler_admin WHERE admin_password=\"" + inNew + "\"");
	    rtn = rset.next();
	}catch(SQLException e){ processException(e); }	
	return rtn;
    }

    // Pre:  inExp, inLog, inFreq conform to the contraints laid out in the
    // readme and are valid Integers.
    // Post: updates administrative settings with new values.
    public void cc_admin_edit(int inExp, boolean inLog, 
			      int inFreq){
	try{
	    int intLog;
	    if(inLog)
		intLog = 1;
	    else
		intLog = 0;
	    stmt.executeUpdate("UPDATE ccrawler_admin SET admin_expire=" +  inExp + 
			       ", admin_log=" + intLog + ", admin_freq=" +inFreq);
	}catch(SQLException e){ processException(e); }	    
    }
    

    /************
     CCRAWLER_SITE
     ************/
    // Pre:  None.
    // Post: returns the name and (base) URL for the contents of the sites table.
    public Object[][] cc_site_list(){
	Object[][] rtn = null;
	try{
	    rset = stmt.executeQuery("SELECT site_name AS Name, site_url AS URL FROM ccrawler_sites ORDER BY site_name");

	    rset.last();
	    int rows = rset.getRow();
	    rset.first();
	    rtn = new Object[rows + 1][2];
	    for(int i = 0; i <= rows; i++){
		if(i == 0){
		    rtn[0][0] = rset.getMetaData().getColumnName(1);
		    rtn[0][1] = rset.getMetaData().getColumnName(2);
		}
		    
		else{
		    rtn[i][0] = rset.getObject(1);
		    rtn[i][1] = rset.getObject(2);
		    rset.next();
		}
		
	    }

	}catch(SQLException e){processException(e);}
	return rtn;
    }

    // Pre:  inName is a valid site_name
    // Post: the site entry and all corresponding word entries are removed
    // from the DB.
    public void cc_site_delete(String inName){
	try{
	    stmt.executeUpdate("DELETE FROM ccrawler_sites WHERE site_name=(\"" + inName +"\")");
	}catch(SQLException e){processException(e);}
    }

    // Pre:  inName is a valid String
    // Post: if inName is in the DB, return true, else return false.
    public Object[][] cc_site_find(String inName){
	Object [][] rtn = null;
	try{
	    rset = stmt.executeQuery("SELECT * FROM ccrawler_sites WHERE site_name=\"" + inName + "\"");
	    rset.last();
	    int rows = rset.getRow();
	    rset.beforeFirst();
	    if(!rset.next())
		return null;
	    rtn = new Object[rows + 1][rset.getMetaData().getColumnCount()];
	    for(int i = 0; i <= rows; i++){
		for(int j = 0; j < rset.getMetaData().getColumnCount(); j++){
		    if(i == 0)
			rtn[i][j] = rset.getMetaData().getColumnName(j + 1);
		    else
			rtn[i][j] = rset.getObject(j + 1);
		}
		if (i != 0)
		    rset.next();
	    }
	    
	}catch(SQLException e){processException(e);}
	return rtn;
    }

    // Pre:  All input is valid and inName <= 50 chars, inURL <= 100 chars,
    // inPre/Post* < 65000 chars.
    // Post: if restrictions or name uniqueness are not met, return
    // false. Else, insert entry and return true.
    public boolean  cc_site_add(String inName, String inURL, boolean inHigher, 
			      String inPreWord, 
			      String inPostWord, String inPreDef, 
			      String inPostDef){
	try{
	    // Enforce length constraints.
	    if(inName.length() > 50 || inURL.length() > 100 || inPreWord.length() > 65000 || 
	       inPostWord.length() > 65000 || inPreDef.length() > 65000 || inPostDef.length() > 65000)
		return false;	    

	    //Strip duplicate spaces from text.
	    int len;
	    inName = inName.replaceAll("\\n", " ");
	    inURL = inURL.replaceAll("\\n", " ");
	    inPreWord = inPreWord.replaceAll("\\n", " ");
	    inPostWord = inPostWord.replaceAll("\\n", " ");
	    inPreDef = inPreDef.replaceAll("\\n", " ");
	    inPostDef = inPostDef.replaceAll("\\n", " ");
	    inName = inName.replace('\n', ' ');
	    inURL = inURL.replace('\n', ' ');
	    inPreWord = inPreWord.replace('\n', ' ');
	    inPostWord = inPostWord.replace('\n', ' ');
	    inPreDef = inPreDef.replace('\n', ' ');
	    inPostDef = inPostDef.replace('\n', ' ');
	    inName = inName.replace('\t', ' ');
	    inURL = inURL.replace('\t', ' ');
	    inPreWord = inPreWord.replace('\t', ' ');
	    inPostWord = inPostWord.replace('\t', ' ');
	    inPreDef = inPreDef.replace('\t', ' ');
	    inPostDef = inPostDef.replace('\t', ' ');
	    if(inURL.indexOf(" ") > -1)
		return false;
	    len = inName.length();
	    while((inName = inName.replaceAll("  ", " ")).length() != len)
		len = inName.length();
	    len = inPreWord.length();
	    while((inPreWord = inPreWord.replaceAll("  ", " ")).length() != len)
		len = inPreWord.length();
	    len = inPostWord.length();
	    while((inPostWord = inPostWord.replaceAll("  ", " ")).length() != len)
		len = inPostWord.length();
	    len = inPreDef.length();
	    while((inPreDef = inPreDef.replaceAll("  ", " ")).length() != len)
		len = inPreDef.length();
	    len = inPostDef.length();
	    while((inPostDef = inPostDef.replaceAll("  ", " ")).length() != len)
		len = inPostDef.length();
	    
	    // Enforce uniqueness.
	    rset = stmt.executeQuery("SELECT site_name FROM ccrawler_sites WHERE site_name = \"" +
				     inName + "\"");
	    if(rset.next())
		return false;

	    //Insert into table.
	    int higher = 0;
	    if (inHigher)
		higher = 1;

	    stmt.executeUpdate("INSERT INTO ccrawler_sites (site_name, site_url, site_allow_higher, " +
			       "site_preword, site_postword, site_predef, site_postdef) " +
			       "VALUES(\"" + inName + "\", \"" + inURL + "\", " + higher + ", \"" + 
			       inPreWord + "\", \"" + inPostWord + "\", \"" + inPreDef + "\", \"" +
			       inPostDef + "\")");	
	}catch(SQLException e){processException(e);}
	    return true;
    }

    // Pre:  All input is valid, and conforms to the specified length constraints.
    // Post: The entry with name = findName is updated with new data.
    public boolean cc_site_edit(String findName, String inName, String inURL, 
			       boolean inHigher,
			       String inPreWord,  String inPostWord, 
			       String inPreDef, String inPostDef){
	try{
	    // Enforce length constraints.
	    if(findName.length() > 50 || inName.length() > 50 || inURL.length() > 100 || 
	       inPreWord.length() > 65000 || inPostWord.length() > 65000 || inPreDef.length() > 65000 || 
	       inPostDef.length() > 65000)
		return false;
	    
	    System.out.println(inPostDef);

	    //Strip duplicate spaces from text.
	    int len;
	    inName = inName.replaceAll("\\n", " ");
	    inURL = inURL.replaceAll("\\n", " ");
	    inPreWord = inPreWord.replaceAll("\\n", " ");
	    inPostWord = inPostWord.replaceAll("\\n", " ");
	    inPreDef = inPreDef.replaceAll("\\n", " ");
	    inPostDef = inPostDef.replaceAll("\\n", " ");
	    inName = inName.replace('\n', ' ');
	    inURL = inURL.replace('\n', ' ');
	    inPreWord = inPreWord.replace('\n', ' ');
	    inPostWord = inPostWord.replace('\n', ' ');
	    inPreDef = inPreDef.replace('\n', ' ');
	    inPostDef = inPostDef.replace('\n', ' ');
	    inName = inName.replace('\t', ' ');
	    inURL = inURL.replace('\t', ' ');
	    inPreWord = inPreWord.replace('\t', ' ');
	    inPostWord = inPostWord.replace('\t', ' ');
	    inPreDef = inPreDef.replace('\t', ' ');
	    inPostDef = inPostDef.replace('\t', ' ');
	    if(inURL.indexOf(" ") > -1)
		return false;
	    len = inName.length();
	    while((inName = inName.replaceAll("  ", " ")).length() != len)
		len = inName.length();
	    len = inPreWord.length();
	    while((inPreWord = inPreWord.replaceAll("  ", " ")).length() != len)
		len = inPreWord.length();
	    len = inPostWord.length();
	    while((inPostWord = inPostWord.replaceAll("  ", " ")).length() != len)
		len = inPostWord.length();
	    len = inPreDef.length();
	    while((inPreDef = inPreDef.replaceAll("  ", " ")).length() != len)
		len = inPreDef.length();
	    len = inPostDef.length();
	    while((inPostDef = inPostDef.replaceAll("  ", " ")).length() != len)
		len = inPostDef.length();

	    // Enforce name's existance and uniqueness
	    rset = stmt.executeQuery("SELECT site_name FROM ccrawler_sites WHERE site_name = \"" +
				     findName + "\"");
	    if(!rset.next())
		return false;
	    
	    if(!findName.equals(inName)){
		rset = stmt.executeQuery("SELECT site_name FROM ccrawler_sites WHERE site_name = \"" +
					 inName + "\"");
		if(rset.next())
		    return false;
	    }
	    int higher = 0;
	    if (inHigher)
		higher = 1;
	    stmt.executeUpdate("UPDATE ccrawler_sites" + 
			       " SET site_name = \"" + inName + "\", site_url = \"" + inURL +
			       "\", site_allow_higher = " + higher + ", site_preword = \"" + inPreWord + "\", site_postword = \"" +
			       inPostWord + "\", site_predef = \"" + inPreDef + "\", site_postdef = \"" +
			       inPostDef + "\" WHERE site_name = \"" + findName + "\"");
	    
	}catch(SQLException e){processException(e);}

	return true;
    }
	
	
	
    /***************
     CCRAWLER_SEARCH
     ***************/

    // Pre:  inWord is a valid word/phrase.
    // Post: returns all results for the given search.
    
    public Object[][] cc_search_find(String inWord){
	return cc_search_find(inWord, false);
    }

    public Object[][] cc_search_find(String inWord, boolean extended){
	Object [][] rtn = null;
	if(inWord.length() > 100)
	    return null;
	String search_val;
	if(extended)
	    //search_val = "%" + inWord.toUpperCase() + " %\" OR \"% " +
	    //inWord.toUpperCase() + "%";
	    search_val = "%" + inWord.toUpperCase() + "%";
	else
	    search_val = inWord.toUpperCase();
	try{
	    rset = stmt.executeQuery("SELECT search_name AS Source, search_word As Term, search_def AS Definition,  " +
				     "search_source AS URL FROM " + "ccrawler_search WHERE search_word LIKE \"" + 
				     search_val + "\" ORDER BY search_rank DESC");
	  
	    rset.last();
	    int rows = rset.getRow();
	    rset.beforeFirst();
	    rtn = new Object[rows][4];
	    if(!rset.next())
		return null;
	    for(int i = 0; i < rows; i++) {
		for(int j = 1; j < 5; j++){
		    rtn[i][j - 1] = rset.getObject(j);
		}	
		rset.next();
	    }
	}catch(SQLException e){processException(e);}
	return rtn;
    }


    // Pre:  inWord & inName are < 50 chars, inAdd = 1 or -1.
    // Post: if there is an entry with inWord and inName, its relative weight
    // is increased or decrased according to inAdd.
    public boolean cc_search_edit_weight(String inWord, String inName, int inAdd){
	if(inName.length() > 100 || inWord.length() > 100)
	    return false;
	try{
	    rset = stmt.executeQuery("SELECT search_rank FROM ccrawler_search WHERE search_name = \"" +
				     inName + "\" AND search_word = \"" + inWord.toUpperCase() + "\"");
	    if(!rset.next())
		return false;
	    int weight = rset.getInt(1);
	    // Increment weight.
	    if(inAdd == 1){
		if (weight >= 1000000000){ // 1,000,000,000 is the max possible weight.
		    stmt.executeUpdate("UPDATE ccrawler_search SET search_rank = search_rank / 2");
		}
		stmt.executeUpdate("UPDATE ccrawler_search SET search_rank = search_rank + 1 WHERE " +
				   "search_name = \"" + inName + "\" AND search_word LIKE \"" +
				   inWord.toUpperCase() + "\"");
	    }else if(inAdd == -1){
		if (weight == 0){
		    System.out.println("UPDATE ccrawler_search SET search_rank = (search_rank / 2) + 1 WHERE "+
				 "search_name NOT \"" + inName + "\" AND search_word LIKE \"" +
				       inWord.toUpperCase() + "\"");
		    stmt.executeUpdate("UPDATE ccrawler_search SET search_rank = (search_rank / 2) + 1 WHERE NOT "+
				       "search_name = \"" + inName + "\", search_word LIKE \"" +
				       inWord.toUpperCase() + "\"");
		}else{
		    stmt.executeUpdate("UPDATE ccrawler_search SET search_rank = search_rank - 1 WHERE " +
				       "search_name = \"" + inName + "\" AND search_word LIKE \"" +
				       inWord.toUpperCase() + "\"");
		}
	    }else
		return false;
	}catch(SQLException e){processException(e);}
	return true;
    }

    // Pre: all parameters are valid strings conforming to length constraints. 
    // Post: if parameters are valid and name references a valid site name,
    // continue, else return false. If there is an old (older than this crawl) entry w/ the same inWord, inName and
    // remove it. If there is not a current entry with this inWord, inName insert it, if so, return false.
    public boolean cc_search_add(String inWord, String inDef, String inName,
				 String inURL){
	//Default value for rank.
	int rank = 500000000;

	// Validate conformance to length constraints.
	if(inWord.length() > 100 || inDef.length() > 65000 || inName.length() > 100 || 
	   inURL.length() > 65000)
	    return false;
	
	// see if old, if so, delete
	try{
	    // Check name validity.
	    rset = stmt.executeQuery("SELECT site_name FROM ccrawler_sites WHERE site_name = \"" + inName + "\"");
	    if(!rset.next())
		return false;
	    
	    //Get current crawl date.
	    rset = stmt.executeQuery("SELECT TO_DAYS(admin_last_crawl) FROM ccrawler_admin");
	    rset.next();
	    int prevCrawl = rset.getInt(1);
	    
	    //Maintain old rank if one exists
	    rset =stmt.executeQuery("SELECT search_rank FROM ccrawler_search WHERE search_word = \""+ inWord.toUpperCase() +
				    "\"");
	    if(rset.next())
		rank = rset.getInt(1);

	    stmt.executeUpdate("DELETE FROM ccrawler_search WHERE search_word = \"" +
			       inWord.toUpperCase() + "\" AND search_name = \"" +
			       inName + "\" AND (TO_DAYS(search_date) < " + 
			       prevCrawl + ")");

	    // If current definition with same inName, inWord, inPrint exists, bail.
	    rset = stmt.executeQuery("SELECT search_word FROM ccrawler_search WHERE search_word = \"" +
				     inWord.toUpperCase() + "\" AND search_name = \"" +
				      inName + "\"");
	    if(rset.next())
		return false;

	    // Insert new def.
	    stmt.executeUpdate("INSERT INTO ccrawler_search (search_word, search_def, search_name," +
			       "search_source, search_rank, search_date) VALUES (\"" + inWord.toUpperCase() +
			       "\", \"" + inDef + "\", \"" + inName + "\", \"" + inURL + "\", " +
			       rank + ", CURRENT_DATE())");
	}catch(SQLException e){processException(e);}
	return true;
    }

    // Pre:  inDays in a valid integer representing the number of days before
    // the most recent crawl to clean.
    // Post: Any search entry made inDays or more before the last crawl and not
    // updated since is removed.
    public void cc_search_clean(int inDays){
	try{
	    rset = stmt.executeQuery("SELECT TO_DAYS(admin_last_crawl) FROM ccrawler_admin");
	    rset.next();
	    int temp = rset.getInt(1);
	    stmt.executeUpdate("DELETE FROM ccrawler_search WHERE TO_DAYS(ADDDATE(search_date, " +
			       "INTERVAL " + inDays + " DAY)) < " + temp);
	    stmt.executeUpdate("UPDATE ccrawler_admin SET admin_last_crawl = CURRENT_DATE()");
	}catch(SQLException e){processException(e);}
    }


    /***************
     CCRAWLER_VISITED
     ***************/

    // Pre:  inURL is a no longer than 200 characters.
    // Post: if inURL is inthe visited list, returns true, else return false.
    public boolean cc_visited_visited(String inURL){
	boolean rtn = false;
	String temp;
	//	System.out.println("Len: " + inURL.length());
	if(inURL.length() <= 200)
	    temp = inURL;
	else
	temp = inURL.substring(0,200);
	try{
	    rset = stmt.executeQuery("SELECT * FROM ccrawler_visited WHERE " +
				     "visited_url = \"" + temp + "\"");
	    rtn = rset.next();
	}catch(SQLException e){processException(e);}
	return rtn;
    }   

    // Pre:  inURL is no more than 100 characters long.
    // Post: inURL is added to listed of visited URLs.
    public void cc_visited_add(String inURL){
	if(!cc_visited_visited(inURL)){
	    String temp;
	    if(inURL.length() <= 200)
		temp = inURL;
	    else
		temp = inURL.substring(0,200);
	    try{
		stmt.executeUpdate("INSERT INTO ccrawler_visited VALUES (\"" + temp +"\")");
	    }catch(SQLException e){processException(e);}
	}
    }

    // Pre:  None.
    // Post: All entries in ccrawler_visited are removed.
    public void cc_visited_clear(){
	try{
	    stmt.executeUpdate("DELETE FROM ccrawler_visited");
	}catch(SQLException e){processException(e);}
    }

    /*************
     CCRAWLER_CRAWL
     *************/

    // Pre:  None.
    // Post: Return false if database flag != 0, else true.
    public boolean cc_crawl_crawler_running(){
	boolean rtn = true;
	try{
	    rset = stmt.executeQuery("SELECT crawl_crawler FROM ccrawler_crawl WHERE crawl_crawler = 1");
	    rtn = rset.next();
	}catch(SQLException e){processException(e);}
	return rtn;
    }
    
    // Pre:  None.
    // Post: Return false if database flag != 0, else true.
    public boolean cc_crawl_parser_running(){
	boolean rtn = true;
	try{
	    rset = stmt.executeQuery("SELECT crawl_crawler FROM ccrawler_crawl WHERE crawl_parser = 1");
	    rtn = rset.next();
	}catch(SQLException e){processException(e);}
	return rtn;
    }

    // Pre:  in is a valid boolean
    // Post: DB flag is set appropriately
    public void cc_crawl_set_parser(boolean in){
	int temp = 0;
	if(in)
	    temp = 1;

	try{
	    stmt.executeUpdate("UPDATE ccrawler_crawl SET crawl_parser = " + temp);
	}catch(SQLException e){processException(e);}
    }

    // Pre:  in is a valid boolean
    // Post: DB flag is set appropriately
    public void cc_crawl_set_crawler(boolean in){
	int temp = 0;
	if(in)
	    temp = 1;

	try{
	    stmt.executeUpdate("UPDATE ccrawler_crawl SET crawl_crawler = " + temp);
	}catch(SQLException e){processException(e);}
    } 

    /************
     PRIVATE FXNS
     ************/


    // Pre:  e is a valid SQL exception
    // Post: prints the stacktrace of e.
    private void processException(SQLException e){
	System.out.println("SQL ERROR!!");
	e.printStackTrace();
	//	System.exit(-1);
    }
}
